IMPORT util
DEFINE datadir STRING
MAIN
  DEFINE w STRING
  DEFINE remoteName,fename STRING
  RUN "cp myGICAPI.js webcomponents/web"
  CALL ui.Interface.frontcall("standard","feinfo", ["datadirectory"],[datadir])
  DISPLAY "datadir:",datadir
  IF datadir IS NULL THEN
    DISPLAY "datadir must be available"
    EXIT PROGRAM 1
  END IF
  IF ui.Interface.getFrontEndName() == "GDC" THEN
    --even with GDC 3.00 we need to upload the component because for some reasons
    --the automatic built in tramsmission fails
    CALL uploadComponent()
  END IF
  OPEN FORM f FROM "main"
  DISPLAY FORM f
  INPUT BY NAME w WITHOUT DEFAULTS ATTRIBUTE(UNBUFFERED)
    ON ACTION show
     --we need to push the pdf to the client side
     LET remoteName=sfmt("%1%2",datadir,"hello.pdf")
     CALL fgl_putfile("hello.pdf",remoteName)
     CALL ui.interface.frontcall("webcomponent", "call", ["formonly.w","displayPDF","file://"||remoteName], [])
  END INPUT
END MAIN


FUNCTION fileList()
  DEFINE f DYNAMIC ARRAY OF STRING
  LET f[f.getLength()+1]="web/myGICAPI.js"
  LET f[f.getLength()+1]="web/web.html"
  LET f[f.getLength()+1]="web/viewer.css"
  LET f[f.getLength()+1]="web/compatibility.js"
  LET f[f.getLength()+1]="web/l10n.js"
  LET f[f.getLength()+1]="web/debugger.js"
  LET f[f.getLength()+1]="web/viewer.js"
  LET f[f.getLength()+1]="web/images/texture.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewThumbnail.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewOutline.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewAttachments.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-sidebarToggle.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageUp.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageDown.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-secondaryToolbarToggle.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomOut.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomIn.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-menuArrows.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewThumbnail@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewOutline@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-viewAttachments@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-sidebarToggle@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageUp@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-pageDown@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-secondaryToolbarToggle@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomOut@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-zoomIn@2x.png"
  LET f[f.getLength()+1]="web/images/toolbarButton-menuArrows@2x.png"
  LET f[f.getLength()+1]="web/locale/locale.properties"
  LET f[f.getLength()+1]="web/locale/en-US/viewer.properties"
  LET f[f.getLength()+1]="build/pdf.worker.js"
  LET f[f.getLength()+1]="build/pdf.js"
  RETURN f
END FUNCTION

FUNCTION uploadComponent()
  DEFINE ostype,ftprefix STRING
  DEFINE flist DYNAMIC ARRAY OF STRING
  DEFINE i INT
  LET ftprefix=datadir,"/webcomponents"
  CALL clientExecute(sfmt('mkdir "%1"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/locale"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/locale/en-US"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/web/images"',ftprefix))
  CALL clientExecute(sfmt('mkdir "%1/build"',ftprefix))
  CALL ui.Interface.frontCall("standard","setwebcomponentpath",[ftprefix],[])
  LET flist=fileList()
  FOR i=1 TO flist.getLength()
    --DISPLAY "transmitting:",flist[i],"..."
    CALL fgl_putfile("webcomponents/"||flist[i],SFMT("%1/%2",ftprefix,flist[i]))
  END FOR
END FUNCTION

FUNCTION clientExecute(cmd)
  DEFINE cmd STRING
  CALL ui.Interface.frontCall("standard","execute",[cmd,1],[])
END FUNCTION
